#!ruby -Ks
=begin
Copyright (C) 2007, 2008 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
=end

rootDir = '.'
dataDir = "#{rootDir}\\data"
outDir = "#{rootDir}"
outFile = "#{outDir}\\data.html" 
urlBase = 'data'

def getNo(id)
  id
end

f = open outFile, 'w'
f.print <<"EOS"
<html>
<head>
<title>data</title>
</head>
<body>
<a name=top>top</a>
EOS

classDir = []
html = ''
Dir.foreach(dataDir){|e|
  path = "#{dataDir}\\#{e}"
  if File.ftype(path) == 'file'
    html += "<a href=#{urlBase}/#{e}>#{e}</a> "
    html += "#{File.mtime(path).strftime('%Y/%m/%d %H:%M:%S')}<br>\n"
    if e =~ /\.csv$/ || e =~ /\.txt$/
      html += <<"EOS"
<textarea rows=5 cols=80>
#{IO.readlines path}
</textarea><br>
EOS
    end    
  elsif e != '.' && e != '..'
    classDir.push e
  end
}
classDir.each{|v1|
  f.print "<a href=##{v1}>#{v1}</a>\n"
}
f.print <<"EOS"
<br><hr>
#{html}
EOS

classDir.each{|v1|
  komaDir = []
  html = ''
  Dir.foreach("#{dataDir}\\#{v1}"){|e|
    path = "#{dataDir}\\#{v1}\\#{e}"
    if File.ftype(path) == 'file'
      html += "<a href=#{urlBase}/#{v1}/#{e}>#{e}</a> "
      html += "#{File.mtime(path).strftime('%Y/%m/%d %H:%M:%S')}<br>\n"
      if e =~ /\.csv$/ || e =~ /\.txt$/
        html += <<"EOS"
<textarea rows=5 cols=80>
#{IO.readlines path}
</textarea><br>
EOS
      end    
    elsif e != '.' && e != '..'
      komaDir.push e
    end
  }
  f.print <<"EOS"
<br><hr>
<a name=#{v1}>#{v1}</a> <a href=#top>top</a>
EOS
  komaDir.each{|v2|
    f.print "<a href=##{v1}#{v2}>#{v2}</a>\n"
  }
  f.print "<br>\n#{html}"
  komaDir.each{|v2|
    f.print <<"EOS"
<br><hr>
<a name=#{v1}#{v2}>#{v2}</a> <a href=#top>top</a><br>
EOS
    tmp = []
    Dir.foreach("#{dataDir}\\#{v1}\\#{v2}"){|v3|
      next if v3 !~ /^(\S+)_(\S+)$/
      tmp.push [getNo($1), $2, v3]
    }
    tmp.sort!{|a, b|
      a1 = a[0]
      b1 = b[0]
      if a1 > b1
        1
      elsif a1 == b1
        0
      else
        -1
      end    
    }
    stDir = []
    html = ''
    tmp.each{|v4|
      f.print "#{v4[0]} #{v4[1]}<br>\n"
      Dir.foreach("#{dataDir}\\#{v1}\\#{v2}\\#{v4[2]}"){|e|
        path = "#{dataDir}\\#{v1}\\#{v2}\\#{v4[2]}\\#{e}"
        if File.ftype(path) == 'file'
          f.print "<a href=\"#{urlBase}/#{v1}/#{v2}/#{v4[2]}/#{e}\">#{e}</a> "
          f.print "#{File.mtime(path).strftime('%Y/%m/%d %H:%M:%S')}<br>\n"
          if e =~ /\.txt$/ || e =~ /\.html$/ 
            c = IO.readlines path
            cols = 80
            len = c.size
            c.each{|line|
              a = line.size
              while a > cols
                len += 1
                a -= cols
              end
            }
            f.print <<"EOS"
<textarea rows=#{len} cols=#{cols}>
#{c}
</textarea><br>
EOS
          end
        end
      }
    }
  }
}

f.print <<"EOS"
</body>
</html>
EOS
f.close
